local score
local wepshot
local ammo = 5
local maxammo = 5
local state = "menu"

local windowx, windowy = love.graphics.getWidth(), love.graphics.getHeight()
local btnx, btny = windowx / 2 - 200, windowy / 4

function love.load()
	background = love.graphics.newImage("images/background.png")
	scope = love.graphics.newImage("images/Scope.png")
	target = love.graphics.newImage("images/target.png")
	shot = love.graphics.newImage("images/shot.png")
	bullet = love.graphics.newImage("images/bullet.png")
	button = love.graphics.newImage("images/button.png")
	shot_sound = love.audio.newSource("sound/glock18.wav", "static")
	reload1 = love.audio.newSource("sound/glock_clipin.wav", "static")
	reload2 = love.audio.newSource("sound/glock_clipout.wav", "static")
	
	local f = love.graphics.newFont(14)
	love.graphics.setFont(f)
	score = 0
	targetx = 100
	targety = 100
	timer, called = 0, 0
	--love.mouse.setVisible(false)
end

function love.draw()
	if state == "menu" then

		love.graphics.print("Total Shootout", windowx / 4, windowy / 6)
		
		love.graphics.draw(button, windowx / 2 - 200, windowy / 4)
		love.graphics.print("Play", btnx + button:getWidth() / 2, btny + button:getHeight() / 2)
		
		love.graphics.draw(button, windowx / 2 - 200, windowy / 3 + 10)
		love.graphics.print("Quit", btnx + button:getWidth() / 2, btny + (button:getHeight() / 2) * 2 + 10)
	elseif state == "game" then
		love.graphics.draw(background, 0, 0)
		x, y = love.mouse.getPosition()
		shotx = x - shot:getWidth() / 2
		shoty = y - shot:getHeight() / 2
		
		love.graphics.draw(scope, scopex, scopey)
		love.graphics.draw(target, targetx, targety)
		love.graphics.draw(button, windowx - button:getWidth(), 0)
		love.graphics.print("Quit", windowx - button:getWidth() / 2, button:getHeight() / 2)
			
		if wepshot == true then
			wepshot = false
			love.graphics.draw(shot, shotx, shoty)
			shot_sound:rewind()
			shot_sound:play()
		end
		
		bulletx = bullet:getWidth()
		bullety = bullet:getHeight()
		if ammo == 5 then
			love.graphics.draw(bullet, bulletx, windowy - bullety -10)
			love.graphics.draw(bullet, bulletx + 20, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 40, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 60, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 80, windowy - bullety - 10)
		elseif ammo == 4 then
			love.graphics.draw(bullet, bulletx, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 20, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 40, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 60, windowy - bullety - 10)
		elseif ammo == 3 then
			love.graphics.draw(bullet, bulletx, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 20, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 40, windowy - bullety - 10)
		elseif ammo == 2 then
			love.graphics.draw(bullet, bulletx, windowy - bullety - 10)
			love.graphics.draw(bullet, bulletx + 20, windowy - bullety - 10)
		elseif ammo == 1 then
			love.graphics.draw(bullet, bulletx, windowy - bullety - 10)
		elseif ammo == 0 then
			Reload()
		end
		
		love.graphics.print("Score: " ..score, 10, 12)
	end
end

function Reload()
	reload1:rewind()
	reload2:rewind()
	
	reload1:play()
	ammo = 5
	reload2:play()
end

function love.update(dt)
	x, y = love.mouse.getPosition()
	scopex = x - scope:getWidth() / 2
	scopey = y - scope:getHeight() / 2
	
	timer = timer + dt
    if timer > 1 and called < 2 then
        randomisetargetPos()
        timer = 0
        called = called + 1
    end
end

function checkMouse(x, y, width, height)
  local mx, my = love.mouse.getPosition()
  return mx >= x and my >= y and mx <= x + width and my <= y + height
end

function randomisetargetPos()
	math.randomseed(os.time())
	math.random(); math.random(); math.random();
	
	targetx = math.random(100, 500)
	targety = math.random(100, 500)
end

function love.mousepressed(x, y, msbutton)
	if state == "menu" then
		if msbutton == 'l' then
			if checkMouse(btnx, btny, button:getWidth(), button:getHeight()) then
				state = "game"
			elseif checkMouse(windowx / 2 - 200, windowy / 3 + 10, button:getWidth(), button:getHeight()) == true then
			end
		end
	elseif state == "game" then
		if checkMouse(windowx - button:getWidth(), 0, button:getWidth(), button:getHeight()) == true then
			state = "menu"
		else
			wepshot = true
			ammo = ammo - 1
			if msbutton == 'l' then
				if checkMouse(targetx, targety, target:getWidth(), target:getHeight()) == true then
					score = score + 1
					randomisetargetPos()
				end
			end
		end
	end
end